////////////////////////////////////////////////////////////////////////////////
//
//  !!!!!!!!!!!!!!!!!!!
//  !!!  READ THIS  !!!
//  !!!!!!!!!!!!!!!!!!!
//
//  3rdPartyLibs contains _modified_ JvBandObject.pas!
//  Remove it for test original file.
//
////////////////////////////////////////////////////////////////////////////////

unit MainForm;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls,
  ComObj, ShlObj,
  JvBandObject, JvBandForms;

type
  // Band Object Factory
  TTestBandFactory = class(TzToolBandObjectFactory)
    procedure UpdateRegistry(Reg: Boolean); override;
  end;

  // Band Object
  TTestToolBand = class(TzToolBandObject)
  protected
    function CreateBandForm(const ParentWnd: THandle): TJvBandForm; override;

  public
    function GetBandInfo(BandID, ViewMode: DWORD; var Dbi: TDeskBandInfo): HRESULT; override;
  end;

  // Band Form
  TMainBandForm = class(TJvBandForm)
    Button1: TButton;

  public
    constructor Create(AOwner: TComponent); override;

  private
    function GetBandObject: TTestToolBand;

  public
    property BandObject: TTestToolBand read GetBandObject;
  end;

var
  MainBandForm: TMainBandForm;

implementation

{$R *.dfm}

uses
  ComServ, SHDocVw, ActiveX;

const
  cTestBandClassId: TGUID = '{6B2BB3F1-E090-4188-8B30-CA2985FB6A88}';
  cTestBandClassName: string = 'TestToolBand';
  cTestBandDescription: string = 'TestToolBand Toolbar';

function ShowToolbar(AClsId: string; AEnable: Boolean): HRESULT;
var
  LWebBrowser: IWebBrowser2;
  vtBandGUID: OleVariant;
  vtShow: OleVariant;
  vtNotUsed: OleVariant;
begin
  Result := CoCreateInstance(CLASS_InternetExplorer, nil, CLSCTX_LOCAL_SERVER, IID_IWebBrowser2,
    LWebBrowser);
  vtBandGUID := AClsId;
  vtShow := AEnable;
  vtNotUsed := 1;
  LWebBrowser.ShowBrowserBar(vtBandGUID, vtShow, vtNotUsed);
  LWebBrowser.Quit;
  LWebBrowser := nil;

  Result := S_OK;
end;

{ TMainBandForm }

constructor TMainBandForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  Constraints.MinHeight := Height;
  Constraints.MaxHeight := Height;
end;

function TMainBandForm.GetBandObject: TTestToolBand;
begin
  Result := TTestToolBand(_BandObject);
end;

{ TTestToolBand }

function TTestToolBand.CreateBandForm(const ParentWnd: THandle): TJvBandForm;
begin
  Result := TMainBandForm.CreateBandForm(ParentWnd, Self);
end;

function TTestToolBand.GetBandInfo(BandID, ViewMode: DWORD; var Dbi: TDeskBandInfo): HRESULT;
begin
  Dbi.dwMask := Dbi.dwMask and (not DBIM_TITLE);
  Result := inherited;
end;

{ TTestBandFactory }

procedure TTestBandFactory.UpdateRegistry(Reg: Boolean);
begin
  if Reg then
    inherited;

  Assert(ShowToolbar(ClassIDString, Reg) = S_OK, 'COM error. Can''t show toolbar.');

  if not Reg then
    inherited UpdateRegistry(Reg);
end;

initialization

TTestBandFactory.Create(ComServer, TTestToolBand, cTestBandClassId, cTestBandClassName,
  cTestBandDescription, ciSingleInstance, tmApartment);

end.
